# Recime Bot Runtime

This runtime is intended to run inside a micro-service container with platform specific integration and module interpreter.

The runtime is used to run chatbots intended for Facebook, Telerik, Slack, Viber, and Wechat. It provides developers the platform specific integration and OAuth integration (e.g. Slack).

# Setup

Create a `.env` file in the root directory with the following properties:

```

BOT_UNIQUE_ID=awesome-bot
HOME_DIR=main-folder

```

Clone the [recime-bot-es6-template](https://github.com/Recime/recime-bot-es6-template) under `main-folder` and rename it to `awesome-bot`.


# Configure

Configure the platform you want to run the bot on. Add the following variables to you `.env` file:

## Facebook

```

RECIME_FACEBOOK_ACCESS_TOKEN=PASTE_YOUR_PAGE_ACCESS_TOKEN
RECIME_FACEBOOK_APP_ID=PASTE_YOUR_APP_ID
RECIME_FACEBOOK_APP_SECRET=PASTE_YOUR_APP_SECRET

```

## Telergram

```
RECIME_TELEGRAM_ACCESS_TOKEN=PASTE_YOUR_TELEGRAM_ACCESS_TOKEN
```

## Viber

```
RECIME_VIBER_ACCESS_TOKEN=PASTE_YOUR_VIBER_ACCESS_TOKEN
```

# Run

Type the following command in your terminal:

```
npm start

```

This is will configure prepare the bot, configure the platform. Go to your bot and start chatting with it.



# License

Copyright © 2017 Recime Inc. All rights reserved.