"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var recime_bot_extension_1 = require("recime-bot-extension");
var Message = /** @class */ (function () {
    function Message(platform) {
        this.__ = recime_bot_extension_1.default[platform];
    }
    Message.prototype.normalizeButton = function (__, content) {
        if (content.buttons) {
            return content.buttons.map(function (button) {
                switch (button.type) {
                    case 'reply': {
                        return __.postbackButton(button.title || button.reply, "reply-" + button.reply);
                    }
                    case 'phone_number': {
                        button.payload = button.payload.replace(/[\s()-]+/ig, '');
                        return button;
                    }
                    default: {
                        return button;
                    }
                }
            });
        }
        return void 0;
    };
    Message.prototype.eval = function (message) {
        var _this = this;
        var __ = this.__;
        switch (message.type) {
            case 'text': {
                if (message.content && message.content.text.trim()) {
                    return __.text(message.content.text, this.normalizeButton(__, message.content));
                }
            }
            case 'image':
            case 'audio':
            case 'video':
            case 'file': {
                return __[message.type](message.content.url, this.normalizeButton(__, message.content));
            }
            case 'button-template': {
                return __.buttonTemplate(message.content.text, this.normalizeButton(__, message.content));
            }
            case 'card-template':
            case 'generic-template': {
                return __.genericTemplate(message.content.elements.map(function (e) {
                    return __.genericItem(e.title, e.subtitle, e.assetId, e.imageUrl, e.actionUrl, _this.normalizeButton(__, e));
                }));
            }
        }
    };
    return Message;
}());
exports.Message = Message;
